#!/usr/bin/perl

# Utility for MDynaMix program to copy EE balancing factors from the output file to the input file.

use strict;

if (2 != @ARGV)
{ 
	print "\nCopyBalancingFactors\n";
	print "====================\n";
	print "Usage: perl CopyBalancingFactors InputFile OutputFile \n\n";
	exit;
}

my $InFile = $ARGV[0]; 
my $OutFile = $ARGV[1];
my $NewInFile = 'temp';

open IN, "$InFile" or die "Can't open $InFile \n";
open OUT, "$OutFile" or die "Can't open $OutFile \n";
open NEW, "> $NewInFile" or die "Can't open $NewInFile \n"; 

my $SerieAverage;
my $mode;
my $WrittenLines = 0; 
while( my $InputFileLine = <IN> )
{			
	if ( $InputFileLine =~ /Number_steps\s+(\d+)/)
	{
		$SerieAverage = $1 / 10.0;
	}
	
	$InputFileLine =~ s/Serie_avegare\s+\d+/Serie_avegare $SerieAverage/;
	
	$InputFileLine =~ s/Average_from\s+\d+/Average_from 2/;
	
	$InputFileLine =~ s/Read_restart\s+.*/Read_restart no/;
	
	$InputFileLine =~ s/Check_only\s+.*/Check_only no/;
	
	if ( $InputFileLine =~ s/(MDEE\s+(\d+)\s+\d+\s+)(.*)/$1manual/)
	{
		print NEW $InputFileLine;
		
		$mode = $3;
		my $SubensNum = $2;
		my $bWrite = 0;		
		
		while( my $OutputFileLine = <OUT> )
		{		
			if (!($bWrite))
			{
				if ($OutputFileLine =~ /#\s+alpha\s+ita\s+prob\.\s+bF\s+F\(kJ\/M\)\s+P\-\s+P\+/)
				{
					$bWrite = 1;
				}	
			}
			else
			{
				if ($WrittenLines < $SubensNum)
				{
					  $OutputFileLine =~ /\d+\s+(\d\.\d+)\s+.*?\s+.*?\s+(.*?)\s+/;
					  print NEW "$1 $2\n";
					  $WrittenLines++;
				}
				else
				{
					last;
				} 
			}						  
		}
		
		if ($mode ne 'auto')
		{
			for(my $i = 0; $i < $SubensNum; $i++)
			{
				next;
			}
		}
	}
	else
	{
		if ($mode eq 'auto')
		{
			print NEW $InputFileLine;
		}
		else
		{
			if ($WrittenLines)
			{
				$WrittenLines--;
			}
			else
			{
				print NEW $InputFileLine;
			}
		}
	}
}

close(IN);
close(OUT);
close(NEW);

rename($InFile, $InFile.'.bak');
rename($NewInFile, $InFile);
unlink($NewInFile);

print "Done!\n";